#include <fstream>
#include <iostream>
#include <cmath>
#include <vector>
using namespace std;
int GCD(int a,int b)
{
    int sgn;
    if(b < 0)
        sgn = 1;
    else
        sgn = 0;
    a = abs(a);
    b = abs(b);
    while(a != 0 && b != 0)
        if(a > b)
            a = a % b;
        else
            b = b % a;
    if(sgn == 0)
        return a + b;
    else
        return -(a + b);
}
int main()
{
    int n , m , i , j , gcd , st = 0;
    ifstream fin("linear.in");
    fin >> n >> m;
    pair<long int , long int> MtG[n][m + 1] , kof;
    vector<bool> Ans(m),is_null(n);
    for(i = 0;i < n;i++)
        for(j = 0;j <= m;j++)
        {
            fin >> MtG[i][j].first;
            MtG[i][j].second = 1;
        }
    ofstream fout("linear.out");
    for(i = 0;i < n;i++)
    {
        st = 0;
        while(st < m && MtG[i][st].first == 0 && !Ans[st])
            st++;
        if(st == m)
        {
            if(MtG[i][st].first != 0)
            {
                fout << "No solution" << endl;
                return 0;
            }
            else
            {
                is_null[i] = true;
                continue;
            }
        }
        kof = MtG[i][st];
        MtG[i][st] = {1 , 1};
        for(j = 0;j <= m;j++)
        {
            if(MtG[i][j].first != 0)
            {
                MtG[i][j].first *= kof.second;
                MtG[i][j].second *= kof.first;
                gcd = GCD(MtG[i][j].first,MtG[i][j].second);
                MtG[i][j].first /= gcd;
                MtG[i][j].second /= gcd;
            }
        }
        for(int k = 0;k < n;k++)
            if(k != i && !is_null[k])
            {
                kof = MtG[k][st];
                for(j = 0;j <= m;j++)
                {
                    if(MtG[i][j].first != 0)
                    {
                        MtG[k][j].first = kof.second*MtG[k][j].first*MtG[i][j].second - kof.first*MtG[i][j].first*MtG[k][j].second;
                        MtG[k][j].second *= MtG[i][j].second*kof.second;
                        gcd = GCD(MtG[k][j].first,MtG[k][j].second);
                        MtG[k][j].first /= gcd;
                        MtG[k][j].second /= gcd;
                    }
                }
            }
        Ans[st] = true;
    }
    for(j = 0;j < m;j++)
        if(!Ans[j])
        {
                for(i = 0;i < n;i++)
                {
                    if(is_null[i])
                        continue;
                    for(j = 0;j < m;j++)
                    {
                        if(MtG[i][j].second == 1)
                            fout << MtG[i][j].first << ' ';
                        else
                            fout << MtG[i][j].first << '/' << MtG[i][j].second << ' ';
                    }
                   if(MtG[i][m].second == 1)
                            fout << MtG[i][m].first << endl;
                        else
                            fout << MtG[i][m].first << '/' << MtG[i][m].second << endl;
                }
                return 0;
        }
    for(i = 0;i < n - 1;i++)
        if(!is_null[i])
        if(MtG[i][m].second == 1)
            fout << MtG[i][m].first << ' ';
        else
            fout << MtG[i][m].first << "/" << MtG[i][m].second << ' ';
    if(MtG[i][m].second == 1)
            fout << MtG[i][m].first<< endl;
    else
            fout << MtG[i][m].first << "/" << MtG[i][m].second << endl;
    return 0;
}
