#include <iostream>
#include <cstdio>
#include <cstdlib>

using namespace std;

long gcd (long a, long b) {
    if(a == 0 || b == 0) return a + b;
    else if(a == 1 || b == 1) return 1;
    else {
        long c;
        do {
            c = a % b;
            a = b; b = c;
        } while(c != 0);
        return a;
    }
}

struct drob {
    long ch, zn;
    inline void sokr() {
        long rr = gcd(labs(ch), labs(zn));
        if(rr != 0) {
            ch /= rr;
            zn /= rr;
        }
        
        if(zn < 0) {
            ch = -ch;
            zn = -zn;
        }
    }
};

//inline void swap()

inline drob operator +(const drob &a, const drob &b) {
    drob res;
    res.ch = a.ch * b.zn + b.ch * a.zn;
    res.zn = a.zn * b.zn;
    res.sokr();
    return res;
}

inline drob operator -(const drob &a, const drob &b) {
    drob res;
    res.ch = a.ch * b.zn - b.ch * a.zn;
    res.zn = a.zn * b.zn;
    res.sokr();
    return res;
}

inline drob operator *(const drob &aa, const drob &bb) {
    drob a = aa, b = bb;
    swap(a.ch, b.ch);
    a.sokr();
    b.sokr();
    drob res;
    res.ch = a.ch * b.ch;
    res.zn = a.zn * b.zn;
    res.sokr();
    return res;
}

inline drob operator /(const drob &a, const drob &bb) {
    drob b = bb;
    swap(b.ch, b.zn);
    drob res = a * b;
    return res;
}

int i, j, a, b, c, d, n, m, k;
drob eq[6201];

inline drob &mas(int i, int j) {
    return eq[(m + 1) * i + j];
}

inline void out(const drob &a) {
    if(!b)
        b = 1;
    else cout << " ";
    if(a.ch == 0 || a.zn == 1) cout << a.ch;
    else cout << a.ch << "/" << a.zn;
}

int main() {
    //cout << gcd(5, 10) << endl;
    freopen("linear.in", "r", stdin);
    freopen("linear.out", "w", stdout);
    cin >> n >> m;
    //cout << n << m;
    
    for(i = 0; i < n; i++)
        for(j = 0; j < m + 1; j++) {
            cin >> mas(i, j).ch;
            mas(i, j).zn = 1;
        }
    
    a = 0;
    for(i = 0; i < n; i++) {
        while(a < m) {
            b = i;
            while(b < n && mas(b, a).ch == 0)
                b++;
            //cout << b << endl;
            if(b >= n) a++; else break;
        }
        if(a >= m) break;
        
        if(b != i)
            for(j = 0; j < m + 1; j++)
                swap(mas(i, j), mas(b, j));
        
        drob rr = mas(i, a);
        for(j = 0; j < m + 1; j++)
            mas(i, j) = mas(i, j) / rr;
            
        for(j = 0; j < n; j++) {
            if(j != i && mas(j, a).ch != 0) {
                drob rz = mas(j, a);
                for(int z = 0; z < m + 1; z++)
                    mas(j, z) = mas(j, z) /rz - mas(i, z);
            }
        }
    }
    
    k = 0;
    for(i = 0; i < n; i++) {
        a = 0;
        for(j = 0; j < m; j++)
            if(mas(i, j).ch != 0)
                a = 1;
        if(!a && mas(i, m).ch != 0) {
            cout << "No solution\n";
            return 0;
        }
        if(a) k++;
    }
    if(k == m) {
        b = 0;
        cout << ' ';
        for(i = 0; i < n; i++) {
            for(j = 0; j < m; j++)
                if(mas(i, j).ch != 0){
                    mas(i, m) = mas(i, m) / mas(i, j);
                    out(mas(i, m));
                    break;
                }
        }
        cout << '\n';
        return 0;
    }
    for(i = 0; i < n; i++) {
        b = c = 0;
        for(j = 0; j < m; j++) {
            if(mas(i, j).ch != 0) {
                c = 1;
                drob rr = mas(i, j);
                for(int z = 0; z < m + 1; z++)
                    mas(i, z) = mas(i, z) / rr;
                break;
            }
        }
        if(c){
            cout << ' ';
            for(j = 0; j < m + 1; j++) {
                out(mas(i, j));
            }
                
            cout << '\n';
        }
    }
    return 0;
}
